Bug 878653 - Review Request: NetworkManager-l2tp - NetworkManager VPN plugin for l2tp
Review Request: NetworkManager-l2tp - NetworkManager VPN plugin for l2tp
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Mathieu Bridon
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-11-20 16:21 EST by Ivan Romanov
Modified: 2012-12-14 00:46 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-12-10 20:25:34 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
bochecha: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Ivan Romanov 2012-11-20 16:21:03 EST
Spec URL: https://raw.github.com/drizt/NetworkManager-l2tp-package/3c1079d46f72fe71d343d6a43cb0b271dfccf4e8/NetworkManager-l2tp.spec
SRPM URL: https://raw.github.com/drizt/NetworkManager-l2tp-package/3c1079d46f72fe71d343d6a43cb0b271dfccf4e8/NetworkManager-l2tp-0.9.6-1.fc18.src.rpm
Description: 
This package contains software for integrating L2TP VPN support with
the NetworkManager and the GNOME desktop.

Fedora Account System Username: ivanromanov
Comment 1 Ivan Romanov 2012-11-20 16:27:40 EST
Koji scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=4710817
Comment 2 Ivan Romanov 2012-11-20 16:29:01 EST
rpmlint output

$ rpmlint NetworkManager-l2tp-0.9.6-1.fc18.src.rpm NetworkManager-l2tp-0.9.6-1.fc18.x86_64.rpm NetworkManager-l2tp-debuginfo-0.9.6-1.fc18.x86_64.rpm
NetworkManager-l2tp.src:94: W: macro-in-comment %{_datadir}
NetworkManager-l2tp.src:95: W: macro-in-comment %{_datadir}
NetworkManager-l2tp.src:51: W: mixed-use-of-spaces-and-tabs (spaces: line 1, tab: line 51)
NetworkManager-l2tp.x86_64: E: zero-length /usr/share/doc/NetworkManager-l2tp-0.9.6/ChangeLog
NetworkManager-l2tp.x86_64: W: non-conffile-in-etc /etc/dbus-1/system.d/nm-l2tp-service.conf
NetworkManager-l2tp.x86_64: W: non-conffile-in-etc /etc/NetworkManager/VPN/nm-l2tp-service.name
3 packages and 0 specfiles checked; 1 errors, 5 warnings.
Comment 3 Mathieu Bridon 2012-11-25 09:55:19 EST
Hi Ivan.

There's still a bit of work needed for this package, so I'm not approving it at the moment.

I summed up all the issues below, so you wouldn't have to hunt them down one by one in the (long) output of fedora-review.

Most of the problems should be pretty quick to fix though, and after that the package should be good to go. :)


Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Summary of issues (details below) :
===================================

[!]: Package requires other packages for directories it uses.
 - The package drops a files in the following directory:
   /usr/share/gnome-vpn-properties/

 => Add a requirement on nm-connection-editor

[!]: If the source package does not include the text of the license(s), the
     packager should contact upstream and encourage them to correct this
     mistake.

 => Please notify upstream of the problem.
 => You might want to consider adding the file yourself if upstream doesn't
    add it:
    https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#License_Text

[!]: License field in the package spec file matches the actual license.

 - The following files are licensed under the LGPLv2+
   auth-dialog/vpn-password-dialog.c
   auth-dialog/vpn-password-dialog.h

 => License tag should read: GPLv2+ and LGPLv2+

[!]: Package consistently uses macro is (instead of hard-coded directory
     names).
 - Note: Using both %{buildroot} and $RPM_BUILD_ROOT

 => See: http://fedoraproject.org/wiki/Packaging/Guidelines#macros

[!]: Package must own all directories that it creates.

 => See above for the /usr/share/gnome-vpn-properties/ folder

[!]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
 - I'm not sure about this one, but the package provides the following:
   libnm-l2tp-properties.so()(64bit)
   nm-l2tp-pppd-plugin.so()(64bit)

 => These seem to be plugins for NetworkManager, shouldn't the Provides be
    filtered out?

[!]: Scriptlets must be sane, if used.
 - There are scriptlets to update the desktop-database and the icon-cache, but
   no corresponding files are installed. (in fact, they are commented out of
   the %files section)

 => If these files really shouldn't be installed, then remove the scriptlets.

[!]: Packages should try to preserve timestamps of original installed files.

 => You can fix that by running install as follows:
    make install DESTDIR=$RPM_BUILD_ROOT INSTALL="/usr/bin/install -p"

[!]: Spec use %global instead of %define.
 - Note:
   %define nm_version 1:0.9.2
   %define dbus_version 1.1
   %define gtk3_version 3.0
   %define ppp_version 2.4.5
   %define shared_mime_version 0.16-3

 => Replace all %define by %global

[!] Rpmlint is silent (or as silent as reasonable)
 - NetworkManager-l2tp.x86_64: E: zero-length /usr/share/doc/NetworkManager-l2tp-0.9.6/ChangeLog

 => You could remove this file, to please rpmlint.

 - NetworkManager-l2tp.x86_64: W: non-conffile-in-etc /etc/dbus-1/system.d/nm-l2tp-service.conf

 => This should be marked as %config, probably even %config(noreplace)

 - NetworkManager-l2tp.x86_64: W: non-conffile-in-etc /etc/NetworkManager/VPN/nm-l2tp-service.name

 => Ignore, this file is in /etc but IMHO they is not a config file.

 - NetworkManager-l2tp.src:94: W: macro-in-comment %{_datadir}
 - NetworkManager-l2tp.src:95: W: macro-in-comment %{_datadir}

 => Instead of commenting them, maybe remove these two files?

 - NetworkManager-l2tp.src:51: W: mixed-use-of-spaces-and-tabs (spaces: line 1, tab: line 51)

 => Not extremely important, but would be nice to fix. :)


===== MUST items =====

C/C++:
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[-]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[!]: Package requires other packages for directories it uses.
 - The package drops a files in the following directory:
   /usr/share/gnome-vpn-properties/

 => Add a requirement on nm-connection-editor

[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[!]: If the source package does not include the text of the license(s), the
     packager should contact upstream and encourage them to correct this
     mistake.

 => Please notify upstream of the problem.
 => You might want to consider adding the file yourself if upstream doesn't
    add it:
    https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#License_Text

[!]: License field in the package spec file matches the actual license.
 - The following files are licensed under the LGPLv2+
   auth-dialog/vpn-password-dialog.c
   auth-dialog/vpn-password-dialog.h

 => License tag should read: GPLv2+ and LGPLv2+

[x]: The spec file handles locales properly.
[!]: Package consistently uses macro is (instead of hard-coded directory
     names).
     Note: Using both %{buildroot} and $RPM_BUILD_ROOT
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Package must own all directories that it creates.
 - See above for the /usr/share/gnome-vpn-properties/ folder

[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[x]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[!]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
 - I'm not sure about this one, but the package provides the following:
   libnm-l2tp-properties.so()(64bit)
   nm-l2tp-pppd-plugin.so()(64bit)

 => These seem to be plugins for NetworkManager, shouldn't the Provides be
    filtered out?

[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: The placement of pkgconfig(.pc) files are correct.
[!]: Scriptlets must be sane, if used.
 - There are scriptlets to update the desktop-database and the icon-cache, but
   no corresponding files are installed. (in fact, they are commented out of
   the %files section)

[x]: SourceX tarball generation or download is documented.
[x]: SourceX / PatchY prefixed with %{name}.
[x]: SourceX is a working URL.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[!]: Packages should try to preserve timestamps of original installed files.

 => You can fix that by running install as follows:
    make install DESTDIR=$RPM_BUILD_ROOT INSTALL="/usr/bin/install -p"

[!]: Spec use %global instead of %define.
     Note: %define nm_version 1:0.9.2 %define dbus_version 1.1 %define
     gtk3_version 3.0 %define ppp_version 2.4.5 %define shared_mime_version
     0.16-3

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: NetworkManager-l2tp-0.9.6-1.fc19.x86_64.rpm
          NetworkManager-l2tp-debuginfo-0.9.6-1.fc19.x86_64.rpm
          NetworkManager-l2tp-0.9.6-1.fc19.src.rpm
NetworkManager-l2tp.x86_64: E: zero-length /usr/share/doc/NetworkManager-l2tp-0.9.6/ChangeLog

 => You could remove this file, to please rpmlint.

NetworkManager-l2tp.x86_64: W: non-conffile-in-etc /etc/dbus-1/system.d/nm-l2tp-service.conf

 => This should be marked as %config, probably even %config(noreplace)

NetworkManager-l2tp.x86_64: W: non-conffile-in-etc /etc/NetworkManager/VPN/nm-l2tp-service.name

 => Ignore, this file is in /etc but IMHO they is not a config file.

NetworkManager-l2tp.src:94: W: macro-in-comment %{_datadir}
NetworkManager-l2tp.src:95: W: macro-in-comment %{_datadir}

 => Instead of commented them, maybe remove these two files?

NetworkManager-l2tp.src:51: W: mixed-use-of-spaces-and-tabs (spaces: line 1, tab: line 51)

 => Not extremely important, but would be nice to fix. :)


Rpmlint (installed packages)
----------------------------
# rpmlint NetworkManager-l2tp NetworkManager-l2tp-debuginfo
NetworkManager-l2tp.x86_64: E: zero-length /usr/share/doc/NetworkManager-l2tp-0.9.6/ChangeLog
NetworkManager-l2tp.x86_64: W: non-conffile-in-etc /etc/dbus-1/system.d/nm-l2tp-service.conf
NetworkManager-l2tp.x86_64: W: non-conffile-in-etc /etc/NetworkManager/VPN/nm-l2tp-service.name
2 packages and 0 specfiles checked; 1 errors, 2 warnings.
# echo 'rpmlint-done:'

 => Same as above.



Requires
--------
NetworkManager-l2tp-0.9.6-1.fc19.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /bin/sh
    NetworkManager >= 1:0.9.2
    dbus >= 1.1
    desktop-file-utils
    gnome-keyring
    libatk-1.0.so.0()(64bit)
    libc.so.6()(64bit)
    libcairo-gobject.so.2()(64bit)
    libcairo.so.2()(64bit)
    libdbus-1.so.3()(64bit)
    libdbus-glib-1.so.2()(64bit)
    libgdk-3.so.0()(64bit)
    libgdk_pixbuf-2.0.so.0()(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgnome-keyring.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libgthread-2.0.so.0()(64bit)
    libgtk-3.so.0()(64bit)
    libnm-glib-vpn.so.1()(64bit)
    libnm-glib.so.4()(64bit)
    libnm-util.so.2()(64bit)
    libpango-1.0.so.0()(64bit)
    libpangocairo-1.0.so.0()(64bit)
    libpthread.so.0()(64bit)
    ppp = 2.4.5
    pptp
    rtld(GNU_HASH)
    shared-mime-info >= 0.16-3
    xl2tpd

NetworkManager-l2tp-debuginfo-0.9.6-1.fc19.x86_64.rpm (rpmlib, GLIBC filtered):
    



Provides
--------
NetworkManager-l2tp-0.9.6-1.fc19.x86_64.rpm:
    
    NetworkManager-l2tp = 0.9.6-1.fc19
    NetworkManager-l2tp(x86-64) = 0.9.6-1.fc19
    libnm-l2tp-properties.so()(64bit)
    nm-l2tp-pppd-plugin.so()(64bit)

NetworkManager-l2tp-debuginfo-0.9.6-1.fc19.x86_64.rpm:
    
    NetworkManager-l2tp-debuginfo = 0.9.6-1.fc19
    NetworkManager-l2tp-debuginfo(x86-64) = 0.9.6-1.fc19



Unversioned so-files
--------------------
NetworkManager-l2tp-0.9.6-1.fc19.x86_64.rpm: /usr/lib64/NetworkManager/libnm-l2tp-properties.so
NetworkManager-l2tp-0.9.6-1.fc19.x86_64.rpm: /usr/lib64/pppd/2.4.5/nm-l2tp-pppd-plugin.so

MD5-sum check
-------------
https://github.com/seriyps/NetworkManager-l2tp/archive/0.9.6/NetworkManager-l2tp-0.9.6.tar.gz :
  CHECKSUM(SHA256) this package     : ff71cf0220b07de7ed7cd8bf0c20ef21b9e361dd4a993d161883a1da8babdc14
  CHECKSUM(SHA256) upstream package : ff71cf0220b07de7ed7cd8bf0c20ef21b9e361dd4a993d161883a1da8babdc14


Generated by fedora-review 0.3.1 (b71abc1) last change: 2012-10-16
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -b 878653
Comment 4 Ivan Romanov 2012-11-25 13:11:13 EST
This errors came from NetworkManager-pptp package. Do I should to inform the NetworkManager-pptp maintainer about it?
Comment 5 Mathieu Bridon 2012-11-25 20:50:48 EST
(In reply to comment #4)
> This errors came from NetworkManager-pptp package. Do I should to inform the
> NetworkManager-pptp maintainer about it?

If the NetworkManager-pptp package has some packaging errors, it could certainly be fixed, yes.

But that's a completely separated issue from this review request.
Comment 7 Ivan Romanov 2012-11-26 01:28:37 EST
> [!]: If the source package does not include the text of the license(s), the
>      packager should contact upstream and encourage them to correct this
>      mistake.
> 
>  => Please notify upstream of the problem.

https://github.com/seriyps/NetworkManager-l2tp/issues/4
Comment 8 Ivan Romanov 2012-11-26 12:37:04 EST
License text issue fixed by upstream.
Comment 9 Mathieu Bridon 2012-11-29 10:14:21 EST
First, taking the issues I had raised before.

[x]: Package requires other packages for directories it uses.
[!]: If the source package does not include the text of the license(s), the
     packager should contact upstream and encourage them to correct this
     mistake.

 => Upstream has been notified, and the next release will include it, so this will do.

[x]: License field in the package spec file matches the actual license.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package must own all directories that it creates.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).

 => As I said I wasn't sure about this, but I see you filtered the provides out, so I trust you figured this was the right thing to do.

[-]: Scriptlets must be sane, if used.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.
[x] Rpmlint is silent (or as silent as reasonable)

The only other difference I see in the spec file is this:

-%if 0%{?fedora} > 16
 BuildRequires: libgnome-keyring-devel
-%else
-BuildRequires: gnome-keyring-devel
-%endif

 => I hadn't seen that the first time, but this is a good change as F16 is EOL soon anyway.

This new package fixes all issues I had found, and doesn't introduce any new one, so I'm approving it.
Comment 10 Ivan Romanov 2012-11-30 02:36:39 EST
New Package SCM Request
=======================
Package Name: NetworkManager-l2tp
Short Description: NetworkManager VPN plugin for l2tp
Owners: ivanromanov
Branches: f17 f18 el6
InitialCC:
Comment 11 Mathieu Bridon 2012-11-30 02:48:29 EST
(In reply to comment #10)
> Branches: f17 f18 el6

The el6 is not going to work because you removed this:

> -%if 0%{?fedora} > 16
>  BuildRequires: libgnome-keyring-devel
> -%else
> -BuildRequires: gnome-keyring-devel
> -%endif

You should add these lines back if you intend to have the package build on el6.
Comment 12 Ivan Romanov 2012-11-30 02:53:47 EST
I will use BuildRequires: gnome-keyring-devel for el6 branch
Comment 13 Jon Ciesla 2012-11-30 08:52:00 EST
Git done (by process-git-requests).
Comment 14 Fedora Update System 2012-11-30 23:40:17 EST
NetworkManager-l2tp-0.9.6-2.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/NetworkManager-l2tp-0.9.6-2.fc17
Comment 15 Fedora Update System 2012-11-30 23:45:07 EST
NetworkManager-l2tp-0.9.6-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/NetworkManager-l2tp-0.9.6-2.fc18
Comment 16 Fedora Update System 2012-12-02 14:32:40 EST
NetworkManager-l2tp-0.9.6-2.fc18 has been pushed to the Fedora 18 testing repository.
Comment 17 Fedora Update System 2012-12-10 20:25:36 EST
NetworkManager-l2tp-0.9.6-2.fc17 has been pushed to the Fedora 17 stable repository.
Comment 18 Fedora Update System 2012-12-11 00:57:46 EST
NetworkManager-l2tp-0.9.6-2.fc18 has been pushed to the Fedora 18 stable repository.
Comment 19 Maurice James 2012-12-13 22:14:02 EST
The package is failing to install. The error is the following


Resolving Dependencies
--> Running transaction check
---> Package NetworkManager-l2tp.x86_64 0:0.9.6-2.fc17 will be installed
--> Processing Dependency: nm-connection-editor for package: NetworkManager-l2tp-0.9.6-2.fc17.x86_64
--> Finished Dependency Resolution
Error: Package: NetworkManager-l2tp-0.9.6-2.fc17.x86_64 (updates)
           Requires: nm-connection-editor
 You could try using --skip-broken to work around the problem
 You could try running: rpm -Va --nofiles --nodigest
Comment 20 Maurice James 2012-12-13 22:14:54 EST
uname -a
Linux charon.tierre.net 3.6.7-4.fc17.x86_64 #1 SMP Tue Nov 20 19:40:01 UTC 2012 x86_64 x86_64 x86_64 GNU/Linux
Comment 21 Ivan Romanov 2012-12-14 00:46:44 EST
https://bugzilla.redhat.com/show_bug.cgi?id=886773

Note You need to log in before you can comment on or make changes to this bug.